<?php

	// Dieses Programm setzt ein aus den Exifdaten eines Bildes eingelesenes Datum und Uhrzeit in das Bild und speichert es unter einem anderen Namen.
	// Autor: Michael Theusner (michael@theusner.eu)
	
	//################################################################################
	// Die Verwendung und Modifikation dieses Programms geschieht auf eigenes Risiko!
	// Fr Bild- oder Datenverlust bernehme ich ausdrcklich keine Verantwortung!
	//################################################################################

	// BEACHTEN: Bei Pfadangaben auch unter Windos den Slash (/) statt Backslash (\) verwenden!!!!

	// julday Bibliothek verwenden
	$path = $_SERVER['DOCUMENT_ROOT'];
	require_once($path . "/php/julday.php");

	// Zeitlimit, die dieses Skript laufen darf in Sekunden (hier: 3600 Sekunden = eine Stunde)
	set_time_limit(3600);
	
//#####################################################################################################
// Eingabeparameter (nach Bedarf modifizieren)
//#####################################################################################################
	
	// Position des Datumstextes im Bild in Pixel.
	// Bezugspunkt ist die Ecke unten links!
	$dx = 10;
	$dy = 10;
	
	// Datums- und Zeitformat (Standardausgabe ist JJJJ-MM-TT HH:MM:SS)
	// Datumsseparator (ergibt mit "-" JJJJ-MM-TT)
	$date_sep = "-";
	
	// Zeitseparator (ergibt mit ":" HH:MM:SS)
	$time_sep = ":";

	// Verzeichnis in dem die Bilder liegen, in die der Datumstext gesetzt werden soll (muss JPEG sein!)
	$images = glob("o:/Bilder/20131002-03_Polarlicht/6D/1080/IMG_*.jpg");
	
	// Verzeichnis, in dem die Bilder mit den Exif-Daten liegen (falls identisch mit $images, dann $exif_file_path auf "" setzen)
	$exif_file_path = "o:/Bilder/20131002-03_Polarlicht/6D/TIFF/";
	// Erweiterung des Dateinamens der Exifbilddateien (muss JPEG oder TIFF sein)
	$exif_file_type = ".TIF";
	
	//Ausgabepfad der modifizierten Bilder
	$path_out = "o:/Bilder/20131002-03_Polarlicht/6D/test/";
	
//####################################################################################################
// Schleife, in der der Datumstext ins Bild gesetzt wird und das modifizierte Bild gespeichert wird
//####################################################################################################
	
	// Fr Test eines Bildes diese Zeile auskommentieren (//) und die darauf folgende einkommentieren (// lschen)
	for ($i = 0; $i < count($images); $i++){
	//for ($i = 0; $i < 1; $i++){
	
		// Bildnummer finden (z.B. fr Canon IMG_1234.jpg, dann wird 1234 herausgesucht. Bei andere Namensstruktur entsprechend anpassen.
		// Damit wird der Ausgabedateiname gebaut oder auch automatisch der Dateiname der Bilddatei mit den Exifdaten.
		preg_match("/IMG_([0-9]{4})/", $images[$i], $m);
		
		// Falls die Exifdaten in anderen Bilddateien zu finden sind, wird hier der Dateiname zusammengebaut - oder die Bilddatei selbst verwendet.
		if ($exif_file_path != ""){
			$exif_file = $exif_file_path . "IMG_" . $m[1] . $exif_file_type;
		} else {
			$exif_file = $images[$i];
		}
	
		// Exifdaten einlesen
		$e = exif_read_data($exif_file);
	
		// DateTimeOriginal verwenden
		$d = $e["DateTimeOriginal"];
	
		// Datumsstring auseinandernehmen
		$year = substr($d, 0, 4);
		$month = substr($d, 5, 2);
		$day = substr($d, 8, 2);
		$hour = substr($d, 11, 2);
		$minute = substr($d, 14, 2);
		$second = substr($d, 17, 2);
	
		// Zeitdifferenz in Sekunden, falls die Kamerauhr falsch ging. Oder Zeitdifferenz zu UTC angeben (fr MEZ $dt = -3600;, fr MESZ $dt = -7200; oder je nach Kamerauhreinstellung).
		// (negativ wenn die Kamerauhr vorgeht, 0 bei bereinstimmung)
		$dt = 0;
		
		// Julianisches Datum inklusive der Zeitdifferenz berechnen
		$jd = julday($month, $day, $year, $hour, $minute, $second) + $dt / 3600.0 / 24.0;
		
		// Aus dem (korrigierten) Julianischen Datum wieder das Datum berechnen.
		jd2gregorian($jd, $month_out, $day_out, $year_out, $hour_out, $minute_out, $second_out);
		
		// Hier wird der Ausgabestring konstruiert, der gleich ins Bild gesetzt wird.
		// Standard ist JJJJ-MM-TT HH:MM:SS
		// Kann man aber bliebig modifizieren. Das sprintf() formatiert die Zahl. In diesem Fall mit fhrenden Nullen - also z.B. 2013-10-02 02:10:55
		$date_out = sprintf("%04d", $year_out) . $date_sep . 
					sprintf("%02d", $month_out) . $date_sep .
					sprintf("%02d", $day_out) . " " .
					sprintf("%02d", $hour_out) . $time_sep .
					sprintf("%02d", $minute_out) . $time_sep .
					sprintf("%02d", $second_out);
		
		// Man kann auch noch die Zeitzone anhngen (wenn gewnscht auskommentieren und modifizieren. Hier Beispiel fr UTC.)
		// $date_out .= " UTC";
		
		// Auf Bildschirm ausgeben
		echo "$i: $year".$date_sep."$month".$date_sep."$day $hour".$time_sep."$minute".$time_sep."$second => $date_out<br>\r\n";
	
		// Bildgre herausfinden, um den Datumstext richtig zu platzieren
		$sim = getimagesize($images[$i]);
	
		// Bilddatei einlesen (nur JPEG mglich!)
		$im = imagecreatefromjpeg($images[$i]);
		
		// Textfarbe whlen (R, B, G)
		$text_color = imagecolorallocate($im, 192, 192, 192);
		
		// Datumstext ins Bild setzen (falls ausgefeilterer Text benutzt werden soll (true type font, andere Schriftart), imagettftext(...) verwenden. Siehe hier: http://www.php.net/manual/en/function.imagettftext.php
		imagestring($im, 5, $dx, $sim[1] - $dy - 13,  $date_out, $text_color);
		
		// Bilddatei mit Datumstext ausgeben (die letzte Zahl gibt die JPEG-Qualitt an, 0-100 - sollte nahe 100 liegen)
		imagejpeg($im, $path_out . "IMG_" . $m[1] . "_date.jpg", 96);
	
	}
		

?>