<?php

function julday($month = 0, $day = 0, $year = 0, $hour = 0.0, $minute = 0.0, $second = 0.0) {

  if ($month==0 and $day==0 and $year==0) {
    date_default_timezone_set('UTC');
	$month = floatval(date("n"));
	$day = floatval(date("j"));
	$year = floatval(date("Y"));
	$hour = floatval(date("G"));
	$minute = floatval(date("i"));
	$second = floatval(date("s"));
  }

  $a = floor((14.0 - $month) / 12.0);
  $y = $year + 4800 - $a;
  $m = $month + 12 * $a - 3;
  $jd = $day + floor((153 * $m + 2) / 5) + 365 * $y + floor($y / 4) - floor($y / 100) + floor($y / 400) - 32045;
  $jd += ($hour - 12.0) / 24.0 + $minute / 24.0 / 60.0 + $second / 24.0 / 3600.0;
  
  return $jd;

}

function jd2gregorian($jd, &$M, &$D, &$Y, &$hour, &$min, &$sec){

	$J = floor($jd + 0.5);
	$j = $J + 32044;
	$g = floor($j / 146097);
	$dg = $j % 146097;
	$c = floor((floor($dg / 36524 + 1) * 3) / 4);
	$dc = $dg - $c * 36524;
	$b = floor($dc/ 1461);
	$db = $dc % 1461;
	$a = floor(((floor($db / 365) + 1) * 3) / 4);
	$da = $db - $a * 365;
	$y = $g * 400 + $c * 100 + $b * 4 + $a;
	$m = floor(($da * 5 + 308) / 153) - 2;
	$d = $da - floor(($m + 4) * 153 / 5) + 122;
	$Y = $y - 4800 + floor(($m + 2) / 12);
	$M = ($m + 2) % 12 + 1;
	$D = $d + 1;

	$f = ($jd + 0.5) - $J;

	$hour = floor($f * 24);
	$min = floor($f * 24 * 60) % 60;
	$sec = round($f * 24 * 3600) % 60;
	
}

?>